Linux Audio

Check our new training course

Loading...
v6.9.4
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# This scripts adds local version information from the version
  5# control system git.
  6#
  7# If something goes wrong, send a mail the kernel build mailinglist
  8# (see MAINTAINERS) and CC Nico Schottelius
  9# <nico-linuxsetlocalversion -at- schottelius.org>.
 10#
 11#
 12
 13usage() {
 14	echo "Usage: $0 [--no-local] [srctree]" >&2
 15	exit 1
 16}
 17
 18no_local=false
 19if test "$1" = "--no-local"; then
 20	no_local=true
 
 21	shift
 22fi
 23
 24srctree=.
 25if test $# -gt 0; then
 26	srctree=$1
 27	shift
 28fi
 29if test $# -gt 0 -o ! -d "$srctree"; then
 30	usage
 31fi
 32
 33scm_version()
 34{
 35	local short=false
 36	local no_dirty=false
 37	local tag
 38
 39	while [ $# -gt 0 ];
 40	do
 41		case "$1" in
 42		--short)
 43			short=true;;
 44		--no-dirty)
 45			no_dirty=true;;
 46		esac
 47		shift
 48	done
 49
 50	cd "$srctree"
 51
 52	if test -n "$(git rev-parse --show-cdup 2>/dev/null)"; then
 53		return
 54	fi
 55
 56	if ! head=$(git rev-parse --verify HEAD 2>/dev/null); then
 57		return
 58	fi
 59
 60	# mainline kernel:  6.2.0-rc5  ->  v6.2-rc5
 61	# stable kernel:    6.1.7      ->  v6.1.7
 62	version_tag=v$(echo "${KERNELVERSION}" | sed -E 's/^([0-9]+\.[0-9]+)\.0(.*)$/\1\2/')
 63
 64	# If a localversion* file exists, and the corresponding
 65	# annotated tag exists and is an ancestor of HEAD, use
 66	# it. This is the case in linux-next.
 67	tag=${file_localversion#-}
 68	desc=
 69	if [ -n "${tag}" ]; then
 70		desc=$(git describe --match=$tag 2>/dev/null)
 71	fi
 72
 73	# Otherwise, if a localversion* file exists, and the tag
 74	# obtained by appending it to the tag derived from
 75	# KERNELVERSION exists and is an ancestor of HEAD, use
 76	# it. This is e.g. the case in linux-rt.
 77	if [ -z "${desc}" ] && [ -n "${file_localversion}" ]; then
 78		tag="${version_tag}${file_localversion}"
 79		desc=$(git describe --match=$tag 2>/dev/null)
 80	fi
 81
 82	# Otherwise, default to the annotated tag derived from KERNELVERSION.
 83	if [ -z "${desc}" ]; then
 84		tag="${version_tag}"
 85		desc=$(git describe --match=$tag 2>/dev/null)
 86	fi
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 87
 88	# If we are at the tagged commit, we ignore it because the version is
 89	# well-defined.
 90	if [ "${tag}" != "${desc}" ]; then
 91
 92		# If only the short version is requested, don't bother
 93		# running further git commands
 94		if $short; then
 95			echo "+"
 96			return
 97		fi
 98		# If we are past the tagged commit, we pretty print it.
 99		# (like 6.1.0-14595-g292a089d78d3)
100		if [ -n "${desc}" ]; then
101			echo "${desc}" | awk -F- '{printf("-%05d", $(NF-1))}'
102		fi
103
104		# Add -g and exactly 12 hex chars.
105		printf '%s%s' -g "$(echo $head | cut -c1-12)"
106	fi
107
108	if ${no_dirty}; then
109		return
110	fi
111
112	# Check for uncommitted changes.
113	# This script must avoid any write attempt to the source tree, which
114	# might be read-only.
115	# You cannot use 'git describe --dirty' because it tries to create
116	# .git/index.lock .
117	# First, with git-status, but --no-optional-locks is only supported in
118	# git >= 2.14, so fall back to git-diff-index if it fails. Note that
119	# git-diff-index does not refresh the index, so it may give misleading
120	# results.
121	# See git-update-index(1), git-diff-index(1), and git-status(1).
122	if {
123		git --no-optional-locks status -uno --porcelain 2>/dev/null ||
124		git diff-index --name-only HEAD
125	} | read dummy; then
126		printf '%s' -dirty
127	fi
128}
129
130collect_files()
131{
132	local file res=
133
134	for file; do
135		case "$file" in
136		*\~*)
137			continue
138			;;
139		esac
140		if test -e "$file"; then
141			res="$res$(cat "$file")"
142		fi
143	done
144	echo "$res"
145}
146
147if [ -z "${KERNELVERSION}" ]; then
148	echo "KERNELVERSION is not set" >&2
149	exit 1
150fi
151
152# localversion* files in the build and source directory
153file_localversion="$(collect_files localversion*)"
154if test ! "$srctree" -ef .; then
155	file_localversion="${file_localversion}$(collect_files "$srctree"/localversion*)"
156fi
157
158if ${no_local}; then
159	echo "${KERNELVERSION}$(scm_version --no-dirty)"
160	exit 0
161fi
162
163if ! test -e include/config/auto.conf; then
164	echo "Error: kernelrelease not valid - run 'make prepare' to update it" >&2
165	exit 1
166fi
167
168# version string from CONFIG_LOCALVERSION
 
 
 
 
 
 
169config_localversion=$(sed -n 's/^CONFIG_LOCALVERSION=\(.*\)$/\1/p' include/config/auto.conf)
 
170
171# scm version string if not at the kernel version tag or at the file_localversion
172if grep -q "^CONFIG_LOCALVERSION_AUTO=y$" include/config/auto.conf; then
173	# full scm version string
174	scm_version="$(scm_version)"
175elif [ "${LOCALVERSION+set}" != "set" ]; then
176	# If the variable LOCALVERSION is not set, append a plus
177	# sign if the repository is not in a clean annotated or
178	# signed tagged state (as git describe only looks at signed
179	# or annotated tags - git tag -a/-s).
180	#
181	# If the variable LOCALVERSION is set (including being set
182	# to an empty string), we don't want to append a plus sign.
183	scm_version="$(scm_version --short)"
 
184fi
185
186echo "${KERNELVERSION}${file_localversion}${config_localversion}${LOCALVERSION}${scm_version}"
v6.2
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# This scripts adds local version information from the version
  5# control systems git, mercurial (hg) and subversion (svn).
  6#
  7# If something goes wrong, send a mail the kernel build mailinglist
  8# (see MAINTAINERS) and CC Nico Schottelius
  9# <nico-linuxsetlocalversion -at- schottelius.org>.
 10#
 11#
 12
 13usage() {
 14	echo "Usage: $0 [--save-scmversion] [srctree]" >&2
 15	exit 1
 16}
 17
 18scm_only=false
 19srctree=.
 20if test "$1" = "--save-scmversion"; then
 21	scm_only=true
 22	shift
 23fi
 
 
 24if test $# -gt 0; then
 25	srctree=$1
 26	shift
 27fi
 28if test $# -gt 0 -o ! -d "$srctree"; then
 29	usage
 30fi
 31
 32scm_version()
 33{
 34	local short
 35	short=false
 
 
 
 
 
 
 
 
 
 
 
 
 36
 37	cd "$srctree"
 38	if test -e .scmversion; then
 39		cat .scmversion
 
 
 
 
 40		return
 41	fi
 42	if test "$1" = "--short"; then
 43		short=true
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 44	fi
 45
 46	# Check for git and a git repo.
 47	if test -z "$(git rev-parse --show-cdup 2>/dev/null)" &&
 48	   head=$(git rev-parse --verify HEAD 2>/dev/null); then
 49
 50		# If we are at a tagged commit (like "v2.6.30-rc6"), we ignore
 51		# it, because this version is defined in the top level Makefile.
 52		if [ -z "$(git describe --exact-match 2>/dev/null)" ]; then
 53
 54			# If only the short version is requested, don't bother
 55			# running further git commands
 56			if $short; then
 57				echo "+"
 58				return
 59			fi
 60			# If we are past a tagged commit (like
 61			# "v2.6.30-rc5-302-g72357d5"), we pretty print it.
 62			if atag="$(git describe 2>/dev/null)"; then
 63				echo "$atag" | awk -F- '{printf("-%05d", $(NF-1))}'
 64			fi
 65
 66			# Add -g and exactly 12 hex chars.
 67			printf '%s%s' -g "$(echo $head | cut -c1-12)"
 
 
 
 
 
 
 
 
 
 
 
 
 68		fi
 69
 70		# Check for uncommitted changes.
 71		# This script must avoid any write attempt to the source tree,
 72		# which might be read-only.
 73		# You cannot use 'git describe --dirty' because it tries to
 74		# create .git/index.lock .
 75		# First, with git-status, but --no-optional-locks is only
 76		# supported in git >= 2.14, so fall back to git-diff-index if
 77		# it fails. Note that git-diff-index does not refresh the
 78		# index, so it may give misleading results. See
 79		# git-update-index(1), git-diff-index(1), and git-status(1).
 80		if {
 81			git --no-optional-locks status -uno --porcelain 2>/dev/null ||
 82			git diff-index --name-only HEAD
 83		} | read dummy; then
 84			printf '%s' -dirty
 85		fi
 
 
 
 
 
 
 
 86	fi
 87}
 88
 89collect_files()
 90{
 91	local file res=
 92
 93	for file; do
 94		case "$file" in
 95		*\~*)
 96			continue
 97			;;
 98		esac
 99		if test -e "$file"; then
100			res="$res$(cat "$file")"
101		fi
102	done
103	echo "$res"
104}
105
106if $scm_only; then
107	if test ! -e .scmversion; then
108		res=$(scm_version)
109		echo "$res" >.scmversion
110	fi
111	exit
 
 
 
 
 
 
 
 
112fi
113
114if ! test -e include/config/auto.conf; then
115	echo "Error: kernelrelease not valid - run 'make prepare' to update it" >&2
116	exit 1
117fi
118
119# localversion* files in the build and source directory
120res="$(collect_files localversion*)"
121if test ! "$srctree" -ef .; then
122	res="$res$(collect_files "$srctree"/localversion*)"
123fi
124
125# CONFIG_LOCALVERSION and LOCALVERSION (if set)
126config_localversion=$(sed -n 's/^CONFIG_LOCALVERSION=\(.*\)$/\1/p' include/config/auto.conf)
127res="${res}${config_localversion}${LOCALVERSION}"
128
129# scm version string if not at a tagged commit
130if grep -q "^CONFIG_LOCALVERSION_AUTO=y$" include/config/auto.conf; then
131	# full scm version string
132	res="$res$(scm_version)"
133elif [ "${LOCALVERSION+set}" != "set" ]; then
134	# If the variable LOCALVERSION is not set, append a plus
135	# sign if the repository is not in a clean annotated or
136	# signed tagged state (as git describe only looks at signed
137	# or annotated tags - git tag -a/-s).
138	#
139	# If the variable LOCALVERSION is set (including being set
140	# to an empty string), we don't want to append a plus sign.
141	scm=$(scm_version --short)
142	res="$res${scm:++}"
143fi
144
145echo "$res"